//  ************************************************************************************************
//
//  BornAgain: simulate and fit reflection and scattering
//
//! @file      GUI/Model/Data/MaskResultsPresenter.h
//! @brief     Defines class MaskResultsPresenter
//!
//! @homepage  http://www.bornagainproject.org
//! @license   GNU General Public License v3 or higher (see COPYING)
//! @copyright Forschungszentrum Jülich GmbH 2018
//! @authors   Scientific Computing Group at MLZ (see CITATION, AUTHORS)
//
//  ************************************************************************************************

#ifndef BORNAGAIN_GUI_MODEL_DATA_MASKRESULTSPRESENTER_H
#define BORNAGAIN_GUI_MODEL_DATA_MASKRESULTSPRESENTER_H

#include "GUI/Model/Data/MaskEditorFlags.h"
#include <QObject>
#include <memory>

class Data2DItem;
class Datafield;

//! Updates bin values inside IntensityData to display current mask state.

class MaskResultsPresenter : public QObject {
    Q_OBJECT
public:
    MaskResultsPresenter(QWidget* parent = nullptr);
    ~MaskResultsPresenter();

    void setContextMRP(Data2DItem* data2DItem);

    void updatePresenter(MaskEditorFlags::PresentationType presentationType);

private:
    void setShowMaskMode();
    void setOriginalMode();
    void backup_data();
    Datafield* createMaskPresentation() const;

    Data2DItem* m_data2DItem;
    std::unique_ptr<Datafield> m_dataBackup;
    bool m_interpolation_flag_backup;
};

#endif // BORNAGAIN_GUI_MODEL_DATA_MASKRESULTSPRESENTER_H
